use utf8;
use constant TRUE  => 1;
use constant FALSE => 0;
use URI::file;

sub gnFirstRun {
   # 初回起動時にウィザードを起動して、gikoNavi.iniとログディレクトリを
   # 指定する
   #
   # 引数: なし
   # 返り値: なし
   
   # Step 1
   # 設定ファイルを格納するディレクトリをFreedesktop.org XDG Base Directory Specに
   # 従って確定する(環境変数HOMEは必ずあるという前提)
   ########################################################################
   $gnCfgPath = "";
   if(&gnGetEnvVal('XDG_CONFIG_HOME')) {
      if(&gnCheckPath(&gnGetEnvVal('XDG_CONFIG_HOME'))) {
         $gnCfgPath = &gnGetEnvVal('XDG_CONFIG_HOME') . "\/gnview\/";
      }
   }
   if($gnCfgPath eq "") {
      my $dir = &gnGetEnvVal('HOME') . "\/.config\/";
      if(&gnCheckPath($dir)) {
         $gnCfgPath = $dir . "gnview\/";
      }
   }
   if($gnCfgPath eq "") {
         $gnCfgPath = &gnGetEnvVal('HOME') . "\/.gnview\/";
   }

   $gnFRxml = Gtk2::GladeXML->new($gladefn, 'gnInitialConfig');
   $gnFRxml->signal_autoconnect_from_package('main');

   my $gnFRwid = $gnFRxml->get_widget('gnInitialConfig_makeInitialConfig_copyInitCfgFile');
   if($gnDebugFlag) { print Dumper($gnFRwid); }
   my $str = $gnFRwid->get_text();
   $str =~ s/CONFIGDIR/$gnCfgPath/;
   $gnFRwid->set_text($str);

   $gnFRwid = $gnFRxml->get_widget('gnInitialConfig_makeInitialConfig_FinalMsg');
   if($gnDebugFlag) { print Dumper($gnFRwid); }
   $str = $gnFRwid->get_text();
   my $str2 = $gnCfgPath . ".gnviewconfig";
   $str =~ s/CONFIGFILENAME/${str2}/;
   $gnFRwid->set_text($str);

   $gnFRwid = $gnFRxml->get_widget('gnInitialConfig_useGikonaviConfig_FinalMsg');
   if($gnDebugFlag) { print Dumper($gnFRwid); }
   $str = $gnFRwid->get_text();
   $str2 = $gnCfgPath . ".gnviewconfig";
   $str =~ s/CONFIGFILENAME/${str2}/;
   $gnFRwid->set_text($str);

   my $gnFirstRunGUI = $gnFRxml->get_widget('gnInitialConfig');
   if($gnDebugFlag) { print Dumper($gnFirstRunGUI); }
   
   my $gnFRIniChoose = $gnFRxml->get_widget('gnFRIniChoose');
   my $gnFRIniFilter = Gtk2::FileFilter->new;
   $gnFRIniFilter->add_pattern('gikoNavi.ini');
   $gnFRIniChoose->set_filter($gnFRIniFilter);
   
   my $gnFRUrlChoose = $gnFRxml->get_widget('gnFRUrlChoose');
   my $gnFRUrlFilter = Gtk2::FileFilter->new;
   $gnFRUrlFilter->add_pattern('url.ini');
   $gnFRUrlChoose->set_filter($gnFRUrlFilter);

   my $gnFRSentChoose = $gnFRxml->get_widget('gnFRSentChoose');
   my $gnFRSentFilter = Gtk2::FileFilter->new;
   $gnFRSentFilter->add_pattern('sent.ini');
   $gnFRSentChoose->set_filter($gnFRSentFilter);

   $gnFirstRunGUI->queue_resize;
   $gnFirstRunGUI->show_all;
   
   my $gnFRpage = 0;
   
}



sub gnFR_next_L1 {
   my $gnFRnote = $gnFRxml->get_widget('gnFRnote');
   # 次のページに進む
   $gnFRnote->next_page;
   
}

sub gnFR_prev_L1 {
   my $gnFRnote = $gnFRxml->get_widget('gnFRnote');
      # 前のページに戻る
      $gnFRnote->prev_page;
}

sub gnFR_next_if {
   my $gnFR_useGikonavi = $gnFRxml->get_widget('gnFirstRun_useGikonavi');
   if ($gnFR_useGikonavi->get_active) {
      # 「既存のファイルを使用」が選択されていたら
      # 次のページに進む
      my $gnFRnote = $gnFRxml->get_widget('gnFRnote');
      $gnFRnote->next_page;
   }else{
      # 「新規に作成」が選択されていたら
      # 新規作成のフローに進む
      my $gnFRnote = $gnFRxml->get_widget('gnFRnote');
      #8ページ目に進む
      $gnFRnote->set_current_page(7);
   
   }
   
}

sub gnFR_prev_if {
      my $gnFRnote = $gnFRxml->get_widget('gnFRnote');
      #8ページ目に進む
      $gnFRnote->set_current_page(1);
   
}

sub gnFR_next_L2 {
   my $gnFRnote = $gnFRxml->get_widget('gnFRnote2');
   # 次のページに進む
   $gnFRnote->next_page;
   
}

sub gnFR_prev_L2 {
   my $gnFRnote = $gnFRxml->get_widget('gnFRnote2');
      # 前のページに戻る
      $gnFRnote->prev_page;
}

sub on_gnFirstrun_exit1_clicked {
      my $gnFirstRunGUI = $gnFRxml->get_widget('gnInitialConfig');
      my $gnMsgDialog = Gtk2::MessageDialog->new($gnFirstRunGUI,
                                                    'GTK_DIALOG_MODAL',
                                                    'GTK_MESSAGE_INFO',
                                                    'GTK_BUTTONS_YES_NO',
                                                    "初期設定を中断しますか？\n（設定は保存されません）",
                                                     ,
                                                    'GTK_BUTTONS_YES' => 'gtk-yes',
                                                    'GTK_BUTTONS_NO' => 'gtk-no');
      if($gnMsgDialog->run eq 'yes') {
          $gnMsgDialog->destroy;
          undef($gnMsgDialog);
          exit(0);
      }else{
          $gnMsgDialog->destroy;
          undef($gnMsgDialog);
      }
}

sub gnFR_finish {
   # 初期設定の終了処理
   ########################################################################
   
   my $str = "";
   
   # Step 1
   # 設定ファイルを格納するディレクトリをFreedesktop.org XDG Base Directory Specに
   # 従って確定する(環境変数HOMEは必ずあるという前提)
   ########################################################################
   $gnCfgPath = "";
   if(&gnGetEnvVal('XDG_CONFIG_HOME')) {
      if(&gnCheckPath(&gnGetEnvVal('XDG_CONFIG_HOME'))) {
         $gnCfgPath = &gnGetEnvVal('XDG_CONFIG_HOME') . "\/gnview\/";
      }
   }
   if($gnCfgPath eq "") {
      my $dir = &gnGetEnvVal('HOME') . "\/.config\/";
      if(&gnCheckPath($dir)) {
         $gnCfgPath = $dir . "gnview\/";
      }
   }
   if($gnCfgPath eq "") {
         $gnCfgPath = &gnGetEnvVal('HOME') . "\/.gnview\/";
   }
   if (!(&gnCheckPath($gnCfgPath))) {
      &gnMakeDir($gnCfgPath);
      $str .= "\[設定保存用フォルダ\]\n  $gnCfgPath\n";
   }

   # Step 2
   # キャッシュファイルを格納するディレクトリをFreedesktop.org XDG Base Directory Specに
   # 従って確定する(環境変数HOMEは必ずあるという前提)
   # 確定したキャッシュディレクトリは作成され、キャッシュテーブル(設定ディレクトリ/cachetbl.ini)が
   # touchされる
   ########################################################################
   $main::tmpdir = "";
   if(&gnGetEnvVal('XDG_CACHE_HOME')) {
      if(&gnCheckPath(&gnGetEnvVal('XDG_CACHE_HOME'))) {
         $main::tmpdir = &gnGetEnvVal('XDG_CACHE_HOME') . "\/gnview\/";
      }
   }
   if($main::tmpdir eq "") {
      my $dir = &gnGetEnvVal('HOME') . "\/.cache\/";
      if(&gnCheckPath($dir)) {
         $main::tmpdir = $dir . "\/gnview\/";
      }
   }
#   if($main::tmpdir eq "") {
#      my $dir = $gnCfgPath . "\/cache\/";
#      if(&gnCheckPath($dir)) {
#         $main::tmpdir = $dir;
#      }
#   }
   if($main::tmpdir eq "") {
         $main::tmpdir = &gnGetEnvVal('HOME') . "\/.gnview\/cache\/";
   }
   if(!(&gnCheckPath($main::tmpdir))) {
      &gnMakeDir($main::tmpdir);
      $str .= "\[キャッシュ保存用フォルダ\]\n  $main::tmpdir\n";
   }
   # 画像キャッシュテーブルの初期化
   $gnInitCfg{'Main'}{'cachetbl.ini'} = $gnCfgPath . "cachetbl.ini";
   if (!(&gnCheckPath($gnInitCfg{'Main'}{'cachetbl.ini'}))) {
      &gnOpenLocal($gnInitCfg{'Main'}{'cachetbl.ini'}, "w");
      &gnCloseLocal($gnInitCfg{'Main'}{'cachetbl.ini'});
   }




   # Step 3
   # gikoNavi.ini, url.ini, sent.ini の場所を確定
   # 新規の場合は共有ディレクトリから設定ディレクトリにコピーした上で、コピー先を指定
   # ログ保管用ディレクトリを確定
   ########################################################################
   my $gnFR_useGikonavi = $gnFRxml->get_widget('gnFirstRun_useGikonavi');
   if ($gnFR_useGikonavi->get_active) {
      # Step 3-1
      # 「既存のファイルを使用」した場合
      #####################################################################
      my $gnFRIni = $gnFRxml->get_widget('gnFRIniChoose');
      $gnInitCfg{'Main'}{'gikoNavi.ini'} = $gnFRIni->get_filename;
      $gnInitCfg{'Main'}{'gikoNavi.ini'} = Glib::filename_display_name($gnInitCfg{'Main'}{'gikoNavi.ini'});

      if($gnDebugFlag) { print "$gnInitCfg{'Main'}{'gikoNavi.ini'}\n"; }
      
      my $gnFRUrl = $gnFRxml->get_widget('gnFRUrlChoose');
      $gnInitCfg{'Main'}{'url.ini'} = $gnFRUrl->get_filename;
      $gnInitCfg{'Main'}{'url.ini'} = Glib::filename_display_name($gnInitCfg{'Main'}{'url.ini'});
      if($gnDebugFlag) { print "$gnInitCfg{'Main'}{'url.ini'}\n"; }
      
      my $gnFRSent = $gnFRxml->get_widget('gnFRSentChoose');
      $gnInitCfg{'Main'}{'sent.ini'} = $gnFRSent->get_filename;
      $gnInitCfg{'Main'}{'sent.ini'} = Glib::filename_display_name($gnInitCfg{'Main'}{'sent.ini'});
      if($gnDebugFlag) { print "$gnInitCfg{'Main'}{'sent.ini'}\n"; }
      
      my $gnFRLog = $gnFRxml->get_widget('gnFRLogChoose');
      $gnInitCfg{'Main'}{'LogFolder'} = $gnFRLog->get_filename;
      $gnInitCfg{'Main'}{'LogFolder'} = Glib::filename_display_name($gnInitCfg{'Main'}{'LogFolder'});
      if($gnDebugFlag) { print "$gnInitCfg{'Main'}{'LogFolder'}\n"; }
      $logdir = $gnInitCfg{'Main'}{'LogFolder'} . "\/2ch\/";
      
      $gnEnvFile = $gnInitCfg{'Main'}{'gikoNavi.ini'};
      $gnURLIniFile = $gnInitCfg{'Main'}{'url.ini'};
      $gnSentIniFile = $gnInitCfg{'Main'}{'sent.ini'};
      
      #####################################################################
   }else{
      # Step 3-2
      # 「新規に作成」した場合の終了処理
      #####################################################################
      
      # 各種設定ファイルのスケルトンを共有ディレクトリから設定ディレクトリにコピー
      my $gngikoNaviIni_from = &gnGetLibPath . "gikoNavi.ini";
      my $gnurlIni_from = &gnGetLibPath . "url.ini";
      my $gnsentIni_from = &gnGetLibPath . "sent.ini";
      &gnFCopy($gngikoNaviIni_from, $gnCfgPath);
      &gnFCopy($gnurlIni_from, $gnCfgPath);
      &gnFCopy($gnsentIni_from, $gnCfgPath);
      
      $gnInitCfg{'Main'}{'gikoNavi.ini'} = $gnCfgPath . "gikoNavi.ini";
      if($gnDebugFlag) { print "$gnInitCfg{'Main'}{'gikoNavi.ini'}\n"; }
      $gnInitCfg{'Main'}{'url.ini'} = $gnCfgPath . "url.ini";
      if($gnDebugFlag) { print "$gnInitCfg{'Main'}{'url.ini'}\n"; }
      $gnInitCfg{'Main'}{'sent.ini'} = $gnCfgPath . "sent.ini";
      if($gnDebugFlag) { print "$gnInitCfg{'Main'}{'sent.ini'}\n"; }

      my $gnFRLog = $gnFRxml->get_widget('gnFirstrun_LogDirChoose_init');
      if($gnDebugFlag) { print STDERR "1\n"; }
      my $gnFRLog_fn = $gnFRLog->get_filename;
      $gnInitCfg{'Main'}{'LogFolder'} = Glib::filename_display_name($gnFRLog_fn);

      $logdir = $gnInitCfg{'Main'}{'LogFolder'} . "\/2ch\/";
      if($gnDebugFlag) { print "logdir\: " . "$logdir\n"; }      

      $gnEnvFile = $gnInitCfg{'Main'}{'gikoNavi.ini'};
      $gnURLIniFile = $gnInitCfg{'Main'}{'url.ini'};
      $gnSentIniFile = $gnInitCfg{'Main'}{'sent.ini'};

      #####################################################################
   
   }
   # Step 4
   # Step 3で確定したログ保管用フォルダを必要に応じて作成
   ########################################################################
   if (!(&gnCheckPath($logdir))) {
      &gnMakeDir($logdir);
      #mkdir($logdir);
      $str .= "\[ログ保存用フォルダ\]\n  $logdir\n";
   }

   # Step 5
   # Step 1〜4で作成したフォルダをユーザに告知
   ########################################################################
   if($str ne "") {
          $str = "以下のフォルダを作成しました\n\n" . $str;
          my $gnFirstRunGUI = $gnFRxml->get_widget('gnInitialConfig');
          my $gnMsgDialog = Gtk2::MessageDialog->new($gnFirstRunGUI,
                                                     'GTK_DIALOG_MODAL',
                                                     'GTK_MESSAGE_INFO',
                                                     'GTK_BUTTONS_OK',
                                                     $str,
                                                     ,
                                                     'GTK_BUTTONS_OK' => 'gtk-ok');
          if($gnMsgDialog->run eq 'ok') {
             $gnMsgDialog->destroy;
          }
   }

   # Step 6
   # 設定内容を<設定ディレクトリ>/.gnviewconfigに保存
   ########################################################################
   my $gnInitCfgFN = $gnCfgPath . ".gnviewconfig";
   $gnInitCfg{'Main'}{'gnCfgPath'} = $gnCfgPath;
   if($gnDebugFlag) { print Dumper(%gnInitCfg); }
   &gnSaveEnv($gnInitCfgFN, \%gnInitCfg);

   # Step 7
   # 初期設定ウィンドウを閉じ、通常のgnview起動プロセスに戻る
   ########################################################################
   my $gnFirstRunGUI = $gnFRxml->get_widget('gnInitialConfig');
   $gnFirstRunGUI->destroy;
      
   &gnInit;

}


1;

